﻿Type=StaticCode
Version=2
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@
'version 1.10
Sub Process_Globals
	Private buffer(300) As Byte	
	Private length As UInt
	Private bc As ByteConverter
	Public FirstItem() As Byte
	Private numberOfItems As UInt
End Sub

Public Sub AddBytes(b() As Byte)
	If CheckOverflow(b) Then Return
	buffer(length) = b.Length
	bc.ArrayCopy2(b, 0, buffer, length + 1, b.Length)
	length = length + b.Length + 1
	numberOfItems = numberOfItems + 1
	If numberOfItems = 1 Then UpdateFirstItem
End Sub

Private Sub CheckOverflow(b() As Byte) As Boolean
	If length + b.Length > buffer.Length Then
		Log("Buffer overflow! Increase the Queue buffer")
		Return True
	End If
	Return False
End Sub

'Adds bytes to the last added item. Can be called multiple times
Public Sub AddBytesToLastItem(b() As Byte)
	If numberOfItems = 0 Then
		AddBytes(b)
		Return
	End If
	If CheckOverflow(b) Then Return
	Dim LastItemStart As UInt = FindLastItem
	buffer(LastItemStart) = buffer(LastItemStart) + b.Length
	bc.ArrayCopy2(b, 0, buffer, length, b.Length)
	length = length + b.Length
	If numberOfItems = 1 Then UpdateFirstItem
End Sub

Private Sub FindLastItem As UInt
	Dim index As Int = 0
	For i = 0 To numberOfItems - 2
		index = index + buffer(index) + 1
	Next
	Return index
End Sub

Public Sub RemoveFirst
	If numberOfItems = 0 Then
		Log("Buffer underflow!")
		Return
	End If
	Dim firstItemTotalSize As Byte = buffer(0) + 1
	bc.ArrayCopy2(buffer, firstItemTotalSize, buffer, 0, buffer.Length - firstItemTotalSize)
	numberOfItems = numberOfItems - 1
	length = length - firstItemTotalSize
	If numberOfItems > 0 Then UpdateFirstItem
End Sub

Public Sub Size As UInt
	Return numberOfItems
End Sub

Private Sub UpdateFirstItem
	RunNative("SetFirstItem", Null)
End Sub

#if C
void SetFirstItem(B4R::Object* o) {
	b4r_queue::_firstitem->data = (Byte*)b4r_queue::_buffer->data + 1;
	b4r_queue::_firstitem->length = ByteFromArray(b4r_queue::_buffer, 0);
}

#End If